package com.junmp.jyzb.domain;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.Serializable;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

@ApiModel(value = "com-junmp-jyzb-domain-Organization")
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Organization implements Serializable {
    /**
     * 组织机构表ID
     */
    @ApiModelProperty(value = "组织机构表ID")
    private String id;

    /**
     * 组织机构名称
     */
    @ApiModelProperty(value = "组织机构名称")
    private String name;

    /**
     * 组织机构代码
     */
    @ApiModelProperty(value = "组织机构代码")
    private String code;

    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    /**
     * 更新时间
     */
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    /**
     * 组织机构短码
     */
    @ApiModelProperty(value = "组织机构短码")
    private String findCode;

    /**
     * 区域名称
     */
    @ApiModelProperty(value = "区域名称")
    private String areaName;

    /**
     * 装备总数
     */
    @ApiModelProperty(value = "装备总数")
    private Integer equipmentNumber;

    /**
     * 使用次数
     */
    @ApiModelProperty(value = "使用次数")
    private Integer useNumber;

    /**
     * 使用状态（0:启用,1:停用）
     */
    @ApiModelProperty(value = "使用状态（0:启用,1:停用）")
    private Integer state;

    /**
     * 父类ID
     */
    @ApiModelProperty(value = "父类ID")
    private String parentId;

    private static final long serialVersionUID = 1L;
}