package com.junmp.jyzb.service.impl;

import com.alibaba.fastjson2.util.DateUtils;
import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.junmp.jyzb.domain.PoliceFinger;
import com.junmp.jyzb.mapper.PoliceFingerMapper;
import com.junmp.jyzb.mapper.PolicemanMapper;
import com.junmp.jyzb.service.PolicemanService;
import com.junmp.jyzb.utils.DateTimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.junmp.jyzb.domain.Policeman;

import java.util.*;

@Service
public class PolicemanServiceImpl implements PolicemanService {

    @Autowired
    private PolicemanMapper policemanMapper;

    @Autowired
    private PoliceFingerMapper policeFingerMapper;

    @Override
    public void addPoliceman(Map<String, Object> policeman) {

        Policeman police =new Policeman();
        //将警员相关信息添加到警员表
        //生成一个uuid
        String uuid = UUID.randomUUID().toString().replaceAll("-", "");
        //生成当前时间
        Date currentDate = DateTimeUtil.getCurrentDateTime();
        police.setId(uuid);
        police.setCreateTime(currentDate);
        police.setOrgId((String) policeman.get("orgId"));
        police.setName((String) policeman.get("name"));
        police.setUpdateUser((String) policeman.get("updateUser"));
        police.setCabinetId((String) policeman.get("cabinetId"));
        police.setSex((String) policeman.get("sex"));
        police.setPhone((String) policeman.get("phone"));
        police.setPoliceCode((String) policeman.get("policeCode"));
        police.setFaceInfo((String) policeman.get("faceInfo"));
        police.setPhoto((String) policeman.get("photo"));
        policemanMapper.addPoliceman(police);

        //一个警员可能有多个指纹信息，用list接收
        List<Map<String, Object>> fingerMsgList = (List<Map<String, Object>>) policeman.get("fingerMsg");
        //遍历指纹信息，将指纹信息添加到指纹表
        for (Map<String, Object> fingerMsg : fingerMsgList) {
            PoliceFinger finger =new PoliceFinger();
            finger.setPoliceId(uuid);
            finger.setName(fingerMsg.get("name").toString());
            finger.setFingerInfo(fingerMsg.get("fingerInfo").toString());
            finger.setCreateTime(currentDate);
            policeFingerMapper.addFingers(finger);
        }

    }

    @Override
    public Map<String,Object> getOnePolice(String id) {
        return policemanMapper.getOnePolice(id);
    }

    @Override
    public void deletePolice(Map<String, Object> msg) {
        //遍历要删除的警员id
        List<Object> policeList = (List<Object>) msg.get("policeList");
        for (Object policeId:policeList){
            policemanMapper.deletePolice(policeId.toString());
        }
    }

    @Override
    public void updatePolice(Map<String, Object> policeman) {
        Policeman police =new Policeman();
        //修改警员相关信息
        //生成当前时间
        Date currentDate = DateTimeUtil.getCurrentDateTime();
        //police.setId(uuid);
        police.setId((String) policeman.get("id"));
        police.setUpdateTime(currentDate);
        police.setOrgId((String) policeman.get("orgId"));
        police.setName((String) policeman.get("name"));
        police.setUpdateUser((String) policeman.get("updateUser"));
        police.setCabinetId((String) policeman.get("cabinetId"));
        police.setSex((String) policeman.get("sex"));
        police.setPhone((String) policeman.get("phone"));
        police.setPoliceCode((String) policeman.get("policeCode"));
        police.setFaceInfo((String) policeman.get("faceInfo"));
        police.setPhoto((String) policeman.get("photo"));
        policemanMapper.updatePolice(police);

        List<Map<String, Object>> fingerMsgList = (List<Map<String, Object>>) policeman.get("fingerMsg");
        //修改指纹相关信息
        for (Map<String, Object> fingerMsg : fingerMsgList) {
            PoliceFinger finger =new PoliceFinger();
            finger.setName(fingerMsg.get("name").toString());
            finger.setFingerInfo(fingerMsg.get("fingerInfo").toString());
            finger.setUpdateTime(currentDate);
            policeFingerMapper.updateFingers(finger);
        }
    }

    @Override
    public List<String> getAllPoliceId(Map<String, Object> orgId) {
        List<String> msg = policemanMapper.getAllPoliceId(orgId.get("orgId").toString());
        return msg;
    }

    @Override
    public void deleteFinger(Map<String, Object> msg) {
        //遍历要删除的警员id
        List<Object> fingerList = (List<Object>) msg.get("fingerList");
        for (Object finger:fingerList){
            policemanMapper.deleteFinger(finger.toString());
        }
    }
}
