package com.junmp.junmpProcess.service.Bussiness;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.databind.JsonNode;
import com.junmp.junmpProcess.common.Result;
import com.junmp.junmpProcess.dto.ApplyDTO;
import com.junmp.junmpProcess.dto.HandleDataDTO;
import com.junmp.junmpProcess.dto.StartProcessInstanceDTO;
import com.junmp.junmpProcess.dto.TaskDTO;
import com.junmp.junmpProcess.entity.ProcessTemplates;
import com.junmp.junmpProcess.vo.HandleDataVO;
import com.junmp.junmpProcess.vo.HistoryProcessInstanceVO;
import com.junmp.junmpProcess.vo.MultiVO;
import com.junmp.junmpProcess.vo.TaskVO;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Map;

public interface WorkProcessService {

    /**
     * 创建表单
     *
     * @return
     */
    boolean createBpmn(JsonNode flowdto);

    /**
     * 获取用户可见表单
     *
     * @return
     */
    Object getFormGroups(String name);

    /**
     * 通过模板id查看流程信息 会附带流程定义id
     *
     * @return
     */
    Result<ProcessTemplates> detail(String templateId);

    /**
     * 通过流程定义id启动流程
     *
     * @return
     */
    Result<Object> start(StartProcessInstanceDTO startProcessInstanceDTO);

    /**
     * 查看我发起的流程
     *
     * @return
     */
    Result<Page<HistoryProcessInstanceVO>> applyList(ApplyDTO applyDTO);

    /**
     * 查看我的待办
     *
     * @return
     */
    Result<Page<TaskVO>> toDoList(TaskDTO taskDTO);

    /**
     * 查看我的已办
     *
     * @return
     */
    Result<Page<TaskVO>> doneList(@RequestBody TaskDTO taskDTO);

    /**
     * 同意
     *
     * @return
     */
    Result agree(HandleDataDTO handleDataDTO);

    /**
     * 委派
     *
     * @return
     */
    Result delegateTask(HandleDataDTO handleDataDTO);

    /**
     * 委派人完成的按钮
     *
     * @return
     */
    Result resolveTask(@RequestBody HandleDataDTO handleDataDTO);

    /**
     * 拒绝
     *
     * @return
     */
    Result refuse(HandleDataDTO handleDataDTO);

    /**
     * 撤销按钮
     *
     * @return
     */
    Result revoke(HandleDataDTO handleDataDTO);

    /**
     * 转办按钮
     *
     * @return
     */
    Result assignee(HandleDataDTO handleDataDTO);

    /**
     * 退回按钮
     *
     * @return
     */
    Result rollback(HandleDataDTO handleDataDTO);

    /**
     * 加签按钮
     *
     * @return
     */
    Result addMulti(HandleDataDTO handleDataDTO);

    /**
     * 查到签上的人
     *
     * @return
     */
    Result<List<MultiVO>> queryMultiUsersInfo(Map<String, Object> map);

    /**
     * 减签按钮
     *
     * @return
     */
    Result deleteMulti(List<String> executionIds);

    /**
     * 评论按钮
     *
     * @return
     */
    Result comments(HandleDataDTO handleDataDTO);

    /**
     * 通过流程实例id查看详情
     *
     * @return
     */
    Result<HandleDataVO> instanceInfo(HandleDataDTO HandleDataDTO);
//    /**
//     * 上传文件
//     * @return
//     */
//    Result<AttachmentVO> upLoadFile(MultipartFile file, HttpServletRequest request);
//    /**
//     * 下载文件
//     * @return
//     */
//    void downLoadFile( String name);
}
